<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Tower Attack: CGame Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Tower Attack
   </div>
   <div id="projectbrief">A simple console game</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classCGame-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CGame Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classCGame.html" title="CGame represents the game with its engine, gamePlan, entities, etc... ">CGame</a> represents the game with its engine, gamePlan, entities, etc...  
 <a href="classCGame.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="game_8h_source.html">game.h</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for CGame:</div>
<div class="dyncontent">
<div class="center"><img src="classCGame__coll__graph.png" border="0" usemap="#CGame_coll__map" alt="Collaboration graph"/></div>
<map name="CGame_coll__map" id="CGame_coll__map">
<area shape="rect" id="node2" href="classCMap.html" title="This class represents a map ( game plan ) with all game objects and entities ( attacker / tower / pat..." alt="" coords="55,184,113,211"/>
<area shape="rect" id="node3" href="classCExit.html" title="represents exit, place where attackers are heading " alt="" coords="57,95,111,121"/>
<area shape="rect" id="node4" href="classCEntity.html" title="Abstract class, used to store entities to map. " alt="" coords="5,5,72,32"/>
<area shape="rect" id="node5" href="structTCoord.html" title="Coordinates, row and col. " alt="" coords="97,5,162,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a2d3fbce1e71491e719df1089c25dc4a7"><td class="memItemLeft" align="right" valign="top"><a id="a2d3fbce1e71491e719df1089c25dc4a7"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>CGame</b> (const <a class="el" href="classCGame.html">CGame</a> &amp;src)=delete</td></tr>
<tr class="separator:a2d3fbce1e71491e719df1089c25dc4a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4db10c09035dc16b32d6c1ef4cca2143"><td class="memItemLeft" align="right" valign="top"><a id="a4db10c09035dc16b32d6c1ef4cca2143"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a4db10c09035dc16b32d6c1ef4cca2143">~CGame</a> ()</td></tr>
<tr class="memdesc:a4db10c09035dc16b32d6c1ef4cca2143"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor, deletes parent towers / attackers pointers. <br /></td></tr>
<tr class="separator:a4db10c09035dc16b32d6c1ef4cca2143"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86617d6e530e5ec64e74464cfe38c372"><td class="memItemLeft" align="right" valign="top"><a id="a86617d6e530e5ec64e74464cfe38c372"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classCGame.html">CGame</a> &amp;src)=delete</td></tr>
<tr class="separator:a86617d6e530e5ec64e74464cfe38c372"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43cc1d9c7e2e841d91d4c107a27571c1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a43cc1d9c7e2e841d91d4c107a27571c1">loadGame</a> (const string &amp;filename, bool newGame)</td></tr>
<tr class="memdesc:a43cc1d9c7e2e841d91d4c107a27571c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares game, loads new or saved game.  <a href="#a43cc1d9c7e2e841d91d4c107a27571c1">More...</a><br /></td></tr>
<tr class="separator:a43cc1d9c7e2e841d91d4c107a27571c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94dd70176edcdc7b0cb16cf461c74652"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a94dd70176edcdc7b0cb16cf461c74652">saveGame</a> (const string &amp;outfile)</td></tr>
<tr class="memdesc:a94dd70176edcdc7b0cb16cf461c74652"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves a game to a file given by parameter structure of a savefile is: Map folder Score how many instances of each attacker are left attackers in the map - A, parent ( template ) id, hp, steps, entrance towers in the map - T, parent ( template ) id, hp, row, col.  <a href="#a94dd70176edcdc7b0cb16cf461c74652">More...</a><br /></td></tr>
<tr class="separator:a94dd70176edcdc7b0cb16cf461c74652"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad391dcddfc35c1d0a7ed37424b7d768e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#ad391dcddfc35c1d0a7ed37424b7d768e">play</a> (void)</td></tr>
<tr class="memdesc:ad391dcddfc35c1d0a7ed37424b7d768e"><td class="mdescLeft">&#160;</td><td class="mdescRight">After the game is loaded, this method is the main game controller, it calls attacks, moves the board and maintains the user input.  <a href="#ad391dcddfc35c1d0a7ed37424b7d768e">More...</a><br /></td></tr>
<tr class="separator:ad391dcddfc35c1d0a7ed37424b7d768e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:acd16ed32e3fb7df57fc7a65417a96c3b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#acd16ed32e3fb7df57fc7a65417a96c3b">parseLine</a> (const string &amp;line)</td></tr>
<tr class="memdesc:acd16ed32e3fb7df57fc7a65417a96c3b"><td class="mdescLeft">&#160;</td><td class="mdescRight">All loaded attacker templates ( parents )  <a href="#acd16ed32e3fb7df57fc7a65417a96c3b">More...</a><br /></td></tr>
<tr class="separator:acd16ed32e3fb7df57fc7a65417a96c3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07b1e4bfe98ede3ce94dfd102e3d5eff"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a07b1e4bfe98ede3ce94dfd102e3d5eff">parseSave</a> (const string &amp;line)</td></tr>
<tr class="memdesc:a07b1e4bfe98ede3ce94dfd102e3d5eff"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parses savefile and saves appropriate attackers / towers.  <a href="#a07b1e4bfe98ede3ce94dfd102e3d5eff">More...</a><br /></td></tr>
<tr class="separator:a07b1e4bfe98ede3ce94dfd102e3d5eff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d5fbebc71e7e6fa40bc329497a68e2b"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a5d5fbebc71e7e6fa40bc329497a68e2b">loadEntities</a> (const string &amp;filename)</td></tr>
<tr class="memdesc:a5d5fbebc71e7e6fa40bc329497a68e2b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads entities (<a class="el" href="classCTower.html" title="Tower is one of the main game objects, it can attack and defend itself from other attackers...">CTower</a>, <a class="el" href="classCAttacker.html" title="Attacker is one of the main game objects, it can attack and defend itself from other towers...">CAttacker</a>) from settings file and stores them.  <a href="#a5d5fbebc71e7e6fa40bc329497a68e2b">More...</a><br /></td></tr>
<tr class="separator:a5d5fbebc71e7e6fa40bc329497a68e2b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8abe1da5e4a2d2bb3eb1244a7d6522b5"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a8abe1da5e4a2d2bb3eb1244a7d6522b5">readNextMove</a> (void)</td></tr>
<tr class="memdesc:a8abe1da5e4a2d2bb3eb1244a7d6522b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Handles user input, places Attackers into the map or saves the game when S is pressed.  <a href="#a8abe1da5e4a2d2bb3eb1244a7d6522b5">More...</a><br /></td></tr>
<tr class="separator:a8abe1da5e4a2d2bb3eb1244a7d6522b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b23c9dcdbfbf427d24297922f7eb4d9"><td class="memItemLeft" align="right" valign="top"><a id="a9b23c9dcdbfbf427d24297922f7eb4d9"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a9b23c9dcdbfbf427d24297922f7eb4d9">moveAndPrint</a> (void)</td></tr>
<tr class="memdesc:a9b23c9dcdbfbf427d24297922f7eb4d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moves all attackers respectively to their speed and animates one moving session. <br /></td></tr>
<tr class="separator:a9b23c9dcdbfbf427d24297922f7eb4d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2dbbc13fbdf70a185d79b076f89499f4"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a2dbbc13fbdf70a185d79b076f89499f4">loadSavedGame</a> (const string &amp;filename)</td></tr>
<tr class="memdesc:a2dbbc13fbdf70a185d79b076f89499f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Loads saved game from file given by parameter.  <a href="#a2dbbc13fbdf70a185d79b076f89499f4">More...</a><br /></td></tr>
<tr class="separator:a2dbbc13fbdf70a185d79b076f89499f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acdb41532fb29eab0a25689e237d87d1e"><td class="memItemLeft" align="right" valign="top"><a id="acdb41532fb29eab0a25689e237d87d1e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#acdb41532fb29eab0a25689e237d87d1e">saveScore</a> () const</td></tr>
<tr class="memdesc:acdb41532fb29eab0a25689e237d87d1e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saves score to file which was set in Config file. <br /></td></tr>
<tr class="separator:acdb41532fb29eab0a25689e237d87d1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:acbc098705a93765dcddcf07fb8718d92"><td class="memItemLeft" align="right" valign="top"><a id="acbc098705a93765dcddcf07fb8718d92"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_score</b></td></tr>
<tr class="separator:acbc098705a93765dcddcf07fb8718d92"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6c0c1a6299bbbcb8fe26d95de5b85c44"><td class="memItemLeft" align="right" valign="top"><a id="a6c0c1a6299bbbcb8fe26d95de5b85c44"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>m_attackersTotal</b></td></tr>
<tr class="separator:a6c0c1a6299bbbcb8fe26d95de5b85c44"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08a714913e87f56a2e8ce0cd9b571f1c"><td class="memItemLeft" align="right" valign="top"><a id="a08a714913e87f56a2e8ce0cd9b571f1c"></a>
string&#160;</td><td class="memItemRight" valign="bottom"><b>m_mapFolder</b></td></tr>
<tr class="separator:a08a714913e87f56a2e8ce0cd9b571f1c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5be7036ee04eebcd9c4eadf74b7e077f"><td class="memItemLeft" align="right" valign="top"><a id="a5be7036ee04eebcd9c4eadf74b7e077f"></a>
<a class="el" href="classCMap.html">CMap</a>&#160;</td><td class="memItemRight" valign="bottom"><b>m_gamePlan</b></td></tr>
<tr class="separator:a5be7036ee04eebcd9c4eadf74b7e077f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11b6e603aa1c43b5080b8e1ceb16d5bf"><td class="memItemLeft" align="right" valign="top"><a id="a11b6e603aa1c43b5080b8e1ceb16d5bf"></a>
vector&lt; pair&lt; <a class="el" href="classCTower.html">CTower</a> *, int &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>m_towers</b></td></tr>
<tr class="separator:a11b6e603aa1c43b5080b8e1ceb16d5bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adb78984d62a00d886e66ebdebd63d84e"><td class="memItemLeft" align="right" valign="top"><a id="adb78984d62a00d886e66ebdebd63d84e"></a>
vector&lt; pair&lt; <a class="el" href="classCAttacker.html">CAttacker</a> *, int &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#adb78984d62a00d886e66ebdebd63d84e">m_attackers</a></td></tr>
<tr class="memdesc:adb78984d62a00d886e66ebdebd63d84e"><td class="mdescLeft">&#160;</td><td class="mdescRight">All loaded tower templates ( parents ) <br /></td></tr>
<tr class="separator:adb78984d62a00d886e66ebdebd63d84e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:a7da2448de770887a482600c5b67513c9"><td class="memItemLeft" align="right" valign="top">ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCGame.html#a7da2448de770887a482600c5b67513c9">operator&lt;&lt;</a> (ostream &amp;os, const <a class="el" href="classCGame.html">CGame</a> &amp;game)</td></tr>
<tr class="memdesc:a7da2448de770887a482600c5b67513c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Output stream operator, this prints the whole game.  <a href="#a7da2448de770887a482600c5b67513c9">More...</a><br /></td></tr>
<tr class="separator:a7da2448de770887a482600c5b67513c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classCGame.html" title="CGame represents the game with its engine, gamePlan, entities, etc... ">CGame</a> represents the game with its engine, gamePlan, entities, etc... </p>
<p>Is responsible for loading, saving and the actual gamePlay </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a5d5fbebc71e7e6fa40bc329497a68e2b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d5fbebc71e7e6fa40bc329497a68e2b">&#9670;&nbsp;</a></span>loadEntities()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::loadEntities </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Loads entities (<a class="el" href="classCTower.html" title="Tower is one of the main game objects, it can attack and defend itself from other attackers...">CTower</a>, <a class="el" href="classCAttacker.html" title="Attacker is one of the main game objects, it can attack and defend itself from other towers...">CAttacker</a>) from settings file and stores them. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>settings file to load </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / corrupted file </dd></dl>

</div>
</div>
<a id="a43cc1d9c7e2e841d91d4c107a27571c1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43cc1d9c7e2e841d91d4c107a27571c1">&#9670;&nbsp;</a></span>loadGame()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::loadGame </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>newgame</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Prepares game, loads new or saved game. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Map / Saved game, depends on newGame </td></tr>
    <tr><td class="paramname">newGame</td><td>Determines whether new game is created or saved game is loaded </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / corrupted file </dd></dl>

</div>
</div>
<a id="a2dbbc13fbdf70a185d79b076f89499f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2dbbc13fbdf70a185d79b076f89499f4">&#9670;&nbsp;</a></span>loadSavedGame()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::loadSavedGame </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>filename</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Loads saved game from file given by parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>to load </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>whether the game was loaded successfully </dd></dl>

</div>
</div>
<a id="acd16ed32e3fb7df57fc7a65417a96c3b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acd16ed32e3fb7df57fc7a65417a96c3b">&#9670;&nbsp;</a></span>parseLine()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::parseLine </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>line</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>All loaded attacker templates ( parents ) </p>
<p>Parses one line from inputFile / inputString, loads appropriate attackers / towers to m_attackers / m_towers.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">line</td><td>string to parse </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / corrupted data </dd></dl>

</div>
</div>
<a id="a07b1e4bfe98ede3ce94dfd102e3d5eff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07b1e4bfe98ede3ce94dfd102e3d5eff">&#9670;&nbsp;</a></span>parseSave()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::parseSave </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>line</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Parses savefile and saves appropriate attackers / towers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">line</td><td>to parse </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>if the input is correct </dd></dl>

</div>
</div>
<a id="ad391dcddfc35c1d0a7ed37424b7d768e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad391dcddfc35c1d0a7ed37424b7d768e">&#9670;&nbsp;</a></span>play()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::play </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>After the game is loaded, this method is the main game controller, it calls attacks, moves the board and maintains the user input. </p>
<dl class="section return"><dt>Returns</dt><dd>whether the player won or not ( more than half the attackers made it to the end ) </dd></dl>

</div>
</div>
<a id="a8abe1da5e4a2d2bb3eb1244a7d6522b5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8abe1da5e4a2d2bb3eb1244a7d6522b5">&#9670;&nbsp;</a></span>readNextMove()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::readNextMove </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Handles user input, places Attackers into the map or saves the game when S is pressed. </p>
<dl class="section return"><dt>Returns</dt><dd>if the input was correct or not </dd></dl>

</div>
</div>
<a id="a94dd70176edcdc7b0cb16cf461c74652"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a94dd70176edcdc7b0cb16cf461c74652">&#9670;&nbsp;</a></span>saveGame()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CGame::saveGame </td>
          <td>(</td>
          <td class="paramtype">const string &amp;&#160;</td>
          <td class="paramname"><em>outfile</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saves a game to a file given by parameter structure of a savefile is: Map folder Score how many instances of each attacker are left attackers in the map - A, parent ( template ) id, hp, steps, entrance towers in the map - T, parent ( template ) id, hp, row, col. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">outfile</td><td>where to save the game </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>success / not </dd></dl>

</div>
</div>
<h2 class="groupheader">Friends And Related Function Documentation</h2>
<a id="a7da2448de770887a482600c5b67513c9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7da2448de770887a482600c5b67513c9">&#9670;&nbsp;</a></span>operator<<</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classCGame.html">CGame</a> &amp;&#160;</td>
          <td class="paramname"><em>game</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">friend</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Output stream operator, this prints the whole game. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">game</td><td>to print </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="game_8h_source.html">game.h</a></li>
<li>game.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
